#!/bin/sh
HEADLESS=0
WRAPLESS=1
while getopts hw: opt > /dev/null 2>&1; do
  case "$opt" in
  h)  HEADLESS=1
      shift;;
  w)  WRAPLESS=0
      shift;;
  # handle negatives
  \?) if ! echo $1 | awk '{ exit ! /^-[0-9]+$/ }'; then
        echo >&2 "usage: $0 [-hw] [n_RULE [n_THREADS]]"
        exit
      fi
  esac
done
#shift `expr $OPTIND - 1`

#cd Projects/java/life3d
#for i in data*.life; do
#  SIZE=`ls -s $i 2> /dev/null | awk '{print $1;}'`
#  if test "$SIZE" = "0"; then
#    rm -f $i
#  fi
#done
ls -alrt data?*.life 2> /dev/null

MAX=12
THREADS=1
OFFSET=2
if test `hostname | cut -c1` = "z"; then
  THREADS=2
elif test `hostname | cut -c1` = "O"; then
  THREADS=1
elif test `hostname | cut -c1` = "I"; then
  THREADS=3
  OFFSET=4
  if test `hostname | grep X 2> /dev/null`; then
    THREADS=1
    OFFSET=`expr $OFFSET + $MAX / 2`
  fi
fi
if test $# -lt 1; then
  day=`date -u +%s/86400 | bc`
  ruleIndex=`expr $day + $OFFSET`
else
  ruleIndex=$1
  if test $# -ge 2; then
    THREADS=$2
  fi
fi
if test $ruleIndex -ge 0; then
  rand=`expr $ruleIndex % $MAX`
else
  rand=$ruleIndex
fi

#COUNT=100; STIRS=2
COUNT=42; STIRS=0
EDGE=0; UNBOUND=0; BLOB=60
FILL=35
NUMBERED=-1
COLUMNS=48

if test $rand -eq 0; then
# (6-H [14]|6 4 2*2 <> 40 21 8 5, 7-D [16]|2*2 12 0 <> 42 26 12 2*2)
# NEIGHBORS=12; RULE=B3/S3; LENGTH=400; PERIOD=1; WRAP=1; SEARCH=glider
  NEIGHBORS=12; RULE=B3/S3; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
  COUNT=42; UNBOUND=0
elif test $rand -eq 1; then
  NEIGHBORS=-18; RULE=B4/S36; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 2; then
  NEIGHBORS=-18; RULE=B4/S46; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 3; then
  NEIGHBORS=22; RULE=B4/S3; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
  COLUMNS=96
elif test $rand -eq 4; then
  NEIGHBORS=22; RULE=B4/S4; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
  COLUMNS=96
elif test $rand -eq 5; then
  NEIGHBORS=26; RULE=B5/S23; LENGTH=400; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 6; then
  NEIGHBORS=26; RULE=B5/S37; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 7; then
  NEIGHBORS=26; RULE=B5/S38; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 8; then
#early favorite has p6,10,16,20
  NEIGHBORS=26; RULE=B5/S45; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 9; then
  NEIGHBORS=26; RULE=B5/S47; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
  UNBOUND=0
elif test $rand -eq 10; then
#early has p3,6
  NEIGHBORS=26; RULE=B5/S56; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
  UNBOUND=0
elif test $rand -eq 11; then
  NEIGHBORS=38; RULE=B78/S78; LENGTH=400; PERIOD=120; WRAP=$WRAPLESS; SEARCH=pattern

# Given up on these... but can be accessed directly
elif test $rand -eq -1; then
## N (p4) [168], (I (p4) [18]/M (p4) [27])
  NEIGHBORS=12; RULE=B3/S456; LENGTH=550; PERIOD=30; WRAP=$WRAPLESS; SEARCH=pattern
    BLOB=100 COUNT=200 UNBOUND=0 NUMBERED=16
#    NUMBERED=19
#    FILL=42
##  NEIGHBORS=12; RULE=B3/S456; LENGTH=550; PERIOD=120; WRAP=$WRAPLESS; SEARCH=pattern
##    COUNT=64; BLOB=35
elif test $rand -eq -2; then
#  no glider
  NEIGHBORS=14; RULE=B3/S5; LENGTH=500; PERIOD=120; WRAP=1; SEARCH=glider
elif test $rand -eq -3; then
  NEIGHBORS=14; RULE=B3/S6; LENGTH=600; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -4; then
# Not GL?
  NEIGHBORS=14; RULE=B4/S34; LENGTH=500; PERIOD=120; WRAP=$WRAPLESS; SEARCH=pattern;
  UNBOUND=0
elif test $rand -eq -5; then
  NEIGHBORS=14; RULE=B45/S56; LENGTH=400; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -6; then
# Not GL
  NEIGHBORS=14; RULE=B46/S34; LENGTH=600; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
  THREADS=1
elif test $rand -eq -7; then
#  no glider
  NEIGHBORS=14; RULE=B5678/S34; LENGTH=600; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -8; then
  NEIGHBORS=-14; RULE=B4/S34; LENGTH=400; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -9; then
  NEIGHBORS=-14; RULE=B46/S34; LENGTH=400; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -10; then
# Not GL
  NEIGHBORS=18; RULE=B4/S45; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -11; then
#  no glider
  NEIGHBORS=-18; RULE=B4/S45; LENGTH=400; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -12; then
  NEIGHBORS=-18; RULE=B4/S567; LENGTH=400; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -13; then
# Not GL
  NEIGHBORS=20; RULE=B4/S45; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -14; then
#  no glider
  NEIGHBORS=22; RULE=B4/S57; LENGTH=400; PERIOD=240; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -15; then
#  Nothing found in a while
  NEIGHBORS=26; RULE=B5/S25; LENGTH=400; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -16; then
  NEIGHBORS=26; RULE=B5/S27; LENGTH=400; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -17; then
  NEIGHBORS=26; RULE=B5/S35; LENGTH=400; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -18; then
  NEIGHBORS=26; RULE=B5/S36; LENGTH=400; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern; EDGE=0
elif test $rand -eq -19; then
  NEIGHBORS=26; RULE=B5/S4; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -20; then
  NEIGHBORS=26; RULE=B5/S58; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -21; then
  NEIGHBORS=26; RULE=B5/S678; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
  UNBOUND=0
elif test $rand -eq -22; then
  NEIGHBORS=26; RULE=B5/S8; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern; UNBOUND=0
elif test $rand -eq -23; then
# Too similar to B58/S58
#  NEIGHBORS=26
#  RULE=B58_14-_17_19_20_22-_26/S58_13-_17_19_20_22_-_26
#  LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
# Too many replicants, since WRAP is 0 puffer p30 errors
  NEIGHBORS=26; RULE=B58/S58; LENGTH=400; PERIOD=2; WRAP=0; SEARCH=pattern
    THREADS=1; UNBOUND=0
elif test $rand -eq -24; then
#  no glider
  RULE=B59_11_14_16_18-_20_22-_26/S59_11_13_14_16_18-_20_22-_26
   NEIGHBORS=26; UNBOUND=0; LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -25; then
#  Nothing found in a while
##conway has p3,6
  NEIGHBORS=26; RULE=B6/S567; LENGTH=400; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern; UNBOUND=0
elif test $rand -eq -26; then
  NEIGHBORS=26; RULE=B6/S57; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -27; then
  NEIGHBORS=26; RULE=B67/S57; LENGTH=400; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -28; then
  NEIGHBORS=26; RULE=B67/S67; LENGTH=250; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern; UNBOUND=0
elif test $rand -eq -29; then
  RULE=B68_12_15-_17_19_21_22-_26/S68_12_13_15-_17_19_21-_26
    NEIGHBORS=26; UNBOUND=0; LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -30; then
  RULE=B6_10-_12_17-_19_21-_26/S6_10-_12_13_17-_19_21-_26
    NEIGHBORS=26; UNBOUND=0; LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -31; then
#  no pattern
  NEIGHBORS=26; RULE=B7/S67; LENGTH=250; PERIOD=0; WRAP=$WRAPLESS; SEARCH=pattern # From Piers Anthony OX
elif test $rand -eq -32; then
  RULE=B_10_12_15_17-_26/S_10_12_13_15_17-_26
    NEIGHBORS=26; UNBOUND=0; LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq -33; then
  NEIGHBORS=38; RULE=B6/S78; LENGTH=400; PERIOD=120; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -34; then
  NEIGHBORS=16; RULE=B4/S35; LENGTH=400; PERIOD=12; WRAP=1; SEARCH=glider
elif test $rand -eq -35; then
  NEIGHBORS=16; RULE=B46/S46; LENGTH=400; PERIOD=120; WRAP=1; SEARCH=glider
fi

echo "$rand: ${NEIGHBORS}${RULE}"
sleep 5
RULESTRIP=`echo $RULE | sed s:/::`
for i in $(seq 1 $THREADS); do
  a=`expr 96 + $i | awk '{ printf("%c",$0); }'`
  if test "$HEADLESS" = "1"; then
    CMD="-classpath classes com/sillycycle/bagleyd/life3d/Life3D"
  else
    CMD="-jar Life3DApp.jar"
  fi
  CMD="nohup java -server $CMD\
 -neighbors=$NEIGHBORS -rule=$RULE\
 -searchCount=$COUNT -excludePeriod=$PERIOD -stirs=$STIRS -wrap=$WRAP\
 -searchLength=$LENGTH -visible=0 -${SEARCH}Search=1 -delay=0\
 -edgeDetection=$EDGE -unboundDetection=$UNBOUND -blobPercent=$BLOB\
 -fillPercent=$FILL -numberedSearch=$NUMBERED -columns=$COLUMNS\
 -windowWidth=0 -windowHeight=0 -windowX=256 -windowY=0 -wireframe=1"
  #echo $CMD
  $CMD > data${NEIGHBORS}${RULESTRIP}_${a}.life 2>&1 &
  if test "$HEADLESS" = "1"; then
    echo $!
  fi
  sleep 4
done

sleep 5
ls -alrt data?*.life
bin/lifecheck.sh
