package com.sillycycle.bagleyd.util;

import java.awt.Point;

public class Point3D extends Point {
	private static final long serialVersionUID = 42L;
	public int z;

	public double getZ() {
		return z;
	}

	public Point3D() {
		super.x = 0;
		super.y = 0;
		this.z = 0;
	}

	public Point3D(int x, int y, int z) {
		super.x = x;
		super.y = y;
		this.z = z;
	}

	public void move(int x, int y, int z) {
		this.z = z;
		super.move(x, y);
	}

	public void translate(int x, int y, int z) {
		this.z += z;
		super.translate(x, y);
	}

	/**
	 * Returns the hashcode for this <code>Point3D</code>.
	 * @return a hash code for this <code>Point3D</code>.
	 */
	@Override
	public int hashCode() {
		long bits = java.lang.Double.doubleToLongBits(getX());
		bits ^= java.lang.Double.doubleToLongBits(getY()) * 31;
		bits ^= java.lang.Double.doubleToLongBits(getZ()) * 29;
		return (((int) bits) ^ ((int) (bits >> 32)));
	}

	/**
	 * Determines whether or not two points are equal. Two instances of
	 * <code>Point3D</code> are equal if the values of their
	 * <code>x</code>, <code>y</code>, and <code>z</code> member fields,
	 * representing * their position in the coordinate space, are the same.
	 * @param obj an object to be compared with this <code>Point3D</code>
	 * @return <code>true</code> if the object to be compared is
	 *         an instance of <code>Point3D</code> and has
	 *         the same values; <code>false</code> otherwise.
	 */
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Point3D) {
			Point3D pt = (Point3D) obj;
			return (x == pt.x) && (y == pt.y) &&
				(z == pt.z);
		}
		return super.equals(obj);
	}
}
